#!/usr/bin/perl
#

#------------------------------------------------
#   vpnserverの制御

$E_ST = '/var/www/CTRL/st_vpn.dat';
open INPUT,"$E_ST";
$Ext_ST=<INPUT>;
close INPUT;

$S_ST = '/var/wctl/st_vpn.dat';
open INPUT,"$S_ST";
$Save_ST=<INPUT>;
close INPUT;

if ($Ext_ST ne $Save_ST) {
  if ($Ext_ST eq "open") {
     system("/usr/sbin/service vpnserver start > /dev/null");
  }

  if ($Ext_ST eq "closed") {
     system("/usr/sbin/service vpnserver stop > /dev/null");
  }
  open (OUTPUT ,">$S_ST");
  print OUTPUT $Ext_ST;
  close OUTPUT;
} else {
  $st_VPN = `ps acx | grep vpnserver | wc -l`;
  $st_VPN =~ s/^\s*(.*?)\s*$/$1/;
  if (($st_VPN ne "0") xor ($Save_ST eq "open")) {
    if ($Save_ST eq "open") {
      $Save_ST = "closed";
    } else {
      $Save_ST = "open";
    }
    open (OUTPUT ,">$E_ST");
    print OUTPUT $Save_ST;
    close OUTPUT;
    open (OUTPUT ,">$S_ST");
    print OUTPUT $Save_ST;
    close OUTPUT;
  }
}

#------------------------------------------------
#   UPnPの制御

$S_ST = '/var/www/CTRL/st_upnpsw.dat';
open INPUT,"$S_ST";
$Ext_ST=<INPUT>;
close INPUT;

if ($Ext_ST eq "set") {
  open (OUTPUT ,">$S_ST");
  print OUTPUT "";
  close OUTPUT;

  system("/usr/bin/php /root/upnp.php > /dev/null");
}

#------------------------------------------------
#   電源の制御

$S_ST = '/var/www/CTRL/st_main.dat';
open INPUT,"$S_ST";
$Ext_ST=<INPUT>;
close INPUT;

if ($Ext_ST ne "") {
  open (OUTPUT ,">$S_ST");
  print OUTPUT "";
  close OUTPUT;
  if ($Ext_ST eq "halt") {
    system("/sbin/shutdown -h now");
  } else {
    system("/sbin/shutdown -r now");
  }
}

#------------------------------------------------
#   USBストレージの自動マウント

$st_dev = `/sbin/fdisk -l | grep "/dev/sda1" | wc -l`;
$st_mnt = `df | grep "/mnt/usbhdd" | wc -l`;
$st_dev=~ s/^\s*(.*?)\s*$/$1/;
$st_mnt=~ s/^\s*(.*?)\s*$/$1/;

if (($st_dev eq "1") and ($st_mnt eq "0")) {
  $st_EFI = `/sbin/fdisk -l | grep "/dev/sda1" | grep EFI | wc -l`;
  $st_EFI=~ s/^\s*(.*?)\s*$/$1/;
  if ($st_EFI eq "1") {
    system("mount /dev/sda2 /mnt/usbhdd");
  } else {
    system("mount /dev/sda1 /mnt/usbhdd");
  }
  if (!-d "/mnt/usbhdd/minidlna") {
    mkdir "/mnt/usbhdd/minidlna";
    chmod 0777, "/mnt/usbhdd/minidlna";
  }
  if (!-d "/mnt/usbhdd/transmission") {
    mkdir "/mnt/usbhdd/transmission";
    chmod 0777, "/mnt/usbhdd/transmission";
  }
}

#------------------------------------------------
#   motion 撮影サイズ変更

$E_ST = '/var/www/CTRL/st_mot.dat';
open INPUT,"$E_ST";
$Ext_ST=<INPUT>;
close INPUT;
$S_ST = '/var/wctl/st_mot.dat';
open INPUT,"$S_ST";
$Save_ST=<INPUT>;
close INPUT;

if ($Ext_ST ne "") {
  if ($Ext_ST ne $Save_ST) {
    if ($Ext_ST eq "640") {
      system("cp /etc/motion/motion.conf.640 /etc/motion/motion.conf");
    } elsif ($Ext_ST eq "320") {
      system("cp /etc/motion/motion.conf.320 /etc/motion/motion.conf");
    } else {
    }
  }
  system("/usr/sbin/service motion restart > /dev/null");
  $Ext_ST = "";
  open (OUTPUT ,">$E_ST");
  print OUTPUT $Ext_ST;
  close OUTPUT;
}

$st_mot_s = `grep ^width /etc/motion/motion.conf`;
$st_mot_s = substr($st_mot_s, 6);
$st_mot_s =~ s/^\s*(.*?)\s*$/$1/;
if ($Save_ST ne $st_mot_s) {
  $Save_ST = $st_mot_s;
  open (OUTPUT ,">$S_ST");
  print OUTPUT $Save_ST;
  close OUTPUT;
} 

#------------------------------------------------
#   DLNAデータベースの再構築（再起動）

$S_ST = '/var/www/CTRL/st_dlna.dat';
open INPUT,"$S_ST";
$Ext_ST=<INPUT>;
close INPUT;

if ($Ext_ST eq "restart") {
  system("rm -f /var/lib/minidlna/files.db");
  system("/usr/sbin/service minidlna restart > /dev/null");
  $Ext_ST = "";
  open (OUTPUT ,">$S_ST");
  print OUTPUT $Ext_ST;
  close OUTPUT;
}

#------------------------------------------------
#   transissionの再起動

$S_ST = '/var/www/CTRL/st_tran.dat';
open INPUT,"$S_ST";
$Ext_ST=<INPUT>;
close INPUT;

if ($Ext_ST eq "restart") {
  system("/usr/sbin/service transmission-daemon restart > /dev/null");
  $Ext_ST = "";
  open (OUTPUT ,">$S_ST");
  print OUTPUT $Ext_ST;
  close OUTPUT;
}

